<?php

namespace App\Http\Controllers\Api\Inicio;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\UserProfiles;
use App\Models\Users;

class InicioController extends Controller {
    public function login( Request $r ) {
        $response = array(
            "error" => false,
            "message" => "Sin error"
        );

        try {
            $login = DB::table("users")
            ->select(
                "users.id", 
                "users.name", 
                "users.email", 
                "users.password", 
                "users.status", 
                DB::Raw("user_profiles.name as profileName"), 
                "user_profiles.permits"
            )
            ->join("user_profiles", "users.user_profile_id", "=", "user_profiles.id")
            ->where("email", $r->email)
            ->whereNull("users.deleted_at")
            ->whereNull("user_profiles.deleted_at")
            ->get();

            if ( count($login) > 0 ) {
                if ( password_verify($r->password, $login[0]->password) ) {
                    $response = array(
                        "error" => false,
                        "message" => "Sin error", 
                        "data" => $login
                    );
                } else {
                    $response = array(
                        "error" => true,
                        "message" => "No se pudo validar la cuenta", 
                        "data" => []
                    );
                }
            } else {
                $response = array(
                    "error" => true,
                    "message" => "No se pudo validar la cuenta", 
                    "data" => []
                );
            }
        } catch ( QueryException $e ) {
            $response = array(
                "error" => true,
                "message" => "Error en la consulta", 
                "data" => $e->getMessage()
            );
        }

        return response()
            ->json($response, 200)
            ->header("Access-Control-Allow-Origin", "*");
    }

    public function recovery( Request $r ) {
        $response = array(
            "error" => false,
            "message" => "Sin error"
        );

        try {
            $user = Users::where("email", $r->email)->get();
            if ( count($user) > 0 ) {
                Users::where("email", $r->email)->update(["remember_token" => $r->token ]);
                $response = array(
                    "error" => false,
                    "message" => "Recibimos tu solicitud, recibiras un correo con los pasos para reiniciar tu contraseña", 
                    "data" => []
                );
            } else {
                $response = array(
                    "error" => true,
                    "message" => "No se encontraron registros", 
                    "data" => []
                );
            }
        } catch ( QueryException $e ) {
            $response = array(
                "error" => true,
                "message" => "Error en la consulta", 
                "data" => $e->getMessage()
            );
        }

        return response()
            ->json($response, 200)
            ->header("Access-Control-Allow-Origin", "*");
    }
}
