<?php

namespace App\Http\Controllers\Api\Integraciones\Tracking;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\Tracking;
use App\Models\TrackingWeight;
use App\Models\CatTracking;
use App\Models\CatMood;
use App\Models\CatSupplements;
use App\Models\TrackingWater;
use App\Models\TrackingExercise;
use App\Models\TrackingNutrition;
use App\Models\TrackingSleep;
use App\Models\TrackingMood;
use App\Models\TrackingEnergy;
use App\Models\TrackingSupplements;
use App\Models\TrackingMeditation;
use App\Models\TrackingMenstrualCycle;
use DateTime;

class TrackingController extends Controller {
    /* Catalogos */
    public function getTrackingCatCategories() {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $CatTracking = CatTracking::select( "id", "name", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', icon ) as icon") )->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $CatTracking
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingCatMood() {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $CatMood = CatMood::select( "id", "name", DB::Raw("CONCAT( '".$_ENV["URL_PATH"]."', icon ) as icon") )->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $CatMood
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingCatSupplements() {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $CatSupplements = CatSupplements::select( "id", "name" )->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $CatSupplements
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingItems ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $Tracking = Tracking::select( "tracking_items" )->where("i_client", $r->id)->first();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $Tracking
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingItems ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $check = Tracking::where("i_client", $r->cliente)->first();

                if ( $check == null ) {
                    $TrackingItems = new Tracking();
                    $TrackingItems->i_client = $r->cliente;
                    $TrackingItems->tracking_items = $r->items;
                    $TrackingItems->save();
                } else {
                    $TrackingItems = Tracking::where("i_client", $r->cliente);
                    $TrackingItems->update(["tracking_items" => $r->items]);
                }

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingWeight ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $Weight = new TrackingWeight();
                $Weight->i_client = $r->id;
                $Weight->date_at = $r->date;
                $Weight->weight = $r->weight;
                $Weight->waist = $r->waist;
                $Weight->hip = $r->hip;
                
                //Files
                if( $r->has("image") ) {
                    $fName = $r->file('image');
                    $fileName = MD5($fName . uniqid() . microtime()) . "." . $fName->getClientOriginalExtension();
                    $fName->move("img/tracking/weight/{$r->id}", $fileName);
                    $Weight->image = "/img/tracking/weight/{$r->id}/" . $fileName;
                }

                $Weight->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingWeight ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingWeight = TrackingWeight::select( "id", "weight", "waist", "hip", "date_at" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingWeight
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingWater ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $Water = new TrackingWater();
                $Water->i_client = $r->id;
                $Water->date_at = $r->date;
                $Water->water = $r->water;
                $Water->i_unit = $r->unit; // 1.- Litros, 2.- Mililitros, 3.- Galones, 4.- Onzas
                $Water->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingWater ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingWater = TrackingWater::select( "id", "water", "i_unit", "date_at" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingWater
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingExercise ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingExercise = new TrackingExercise();
                $TrackingExercise->i_client = $r->id;
                $TrackingExercise->date_at = $r->date;
                $TrackingExercise->done = $r->done;
                $TrackingExercise->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingExercise ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingExercise = TrackingExercise::select( "id", "done", "date_at" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingExercise
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingNutrition ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingNutrition = new TrackingNutrition();
                $TrackingNutrition->i_client = $r->id;
                $TrackingNutrition->date_at = $r->date;
                $TrackingNutrition->done = $r->done;
                $TrackingNutrition->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingNutrition ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingNutrition = TrackingNutrition::select( "id", "done", "date_at" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingNutrition
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingSleep ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingSleep = new TrackingSleep();
                $TrackingSleep->i_client = $r->id;
                $TrackingSleep->date_at = $r->date;
                $TrackingSleep->hours = $r->hours;
                $TrackingSleep->minutes = $r->minutes;
                $TrackingSleep->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingSleep ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingSleep = TrackingSleep::select( "id", "date_at", "hours", "minutes" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingSleep
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingMood ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingMood = new TrackingMood();
                $TrackingMood->i_client = $r->id;
                $TrackingMood->date_at = $r->date;
                $TrackingMood->i_mood = $r->mood;
                $TrackingMood->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingMood ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingMood = TrackingMood::select( "id", "date_at", "i_mood" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingMood
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingEnergy ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingEnergy = new TrackingEnergy();
                $TrackingEnergy->i_client = $r->id;
                $TrackingEnergy->date_at = $r->date;
                $TrackingEnergy->name = $r->name;
                $TrackingEnergy->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingEnergy ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingEnergy = TrackingEnergy::select( "id", "date_at", "name" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingEnergy
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeSupplement ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $CatSupplements = new CatSupplements();
                $CatSupplements->name = $r->name;
                $CatSupplements->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingSupplements ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {

                foreach ( $r->supplements as $item ) {
                    $TrackingSupplements = new TrackingSupplements();
                    $TrackingSupplements->i_client = $r->id;
                    $TrackingSupplements->date_at = $r->date;
                    $TrackingSupplements->i_supplement = $item;
                    $TrackingSupplements->save();
                }

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingSupplements ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingSupplements = TrackingSupplements::select( "id", "date_at", "i_supplement" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingSupplements
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingMeditation ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingMeditation = new TrackingMeditation();
                $TrackingMeditation->i_client = $r->id;
                $TrackingMeditation->date_at = $r->date;
                $TrackingMeditation->done = $r->done;
                $TrackingMeditation->save();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Registro exitoso", 
                    "data" => []
                );
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingMeditation ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingMeditation = TrackingMeditation::select( "id", "date_at", "done" )->where("i_client", $r->id)->get();

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $TrackingMeditation
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function storeTrackingMenstrualCycle ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $dateInput = date("Y-m-d", strtotime($r->date));
                $validaFecha = TrackingMenstrualCycle::where("i_client", $r->id)
                ->whereBetween("date_at", [$dateInput." 00:00:00", $dateInput." 23:59:59"])
                ->first();
                
                if ( $validaFecha == null ) {
                    $TrackingMenstrualCycle = new TrackingMenstrualCycle();
                    $TrackingMenstrualCycle->i_client = $r->id;
                    $TrackingMenstrualCycle->date_at = $r->date;
                    $TrackingMenstrualCycle->days = $r->days;
                    $TrackingMenstrualCycle->save();

                    $restResponse = 200;
                    $response = array(
                        "error" => false,
                        "message" => "Registro exitoso", 
                        "data" => []
                    );
                } else {
                    $restResponse = 422;
                    $response = array(
                        "error" => true,
                        "message" => "Registro duplicado",
                        "errors" => array(
                            "fecha" => array("La fecha ya se encuentra registrada")
                        ), 
                        "data" => []
                    );
                }
            
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }

    public function getTrackingMenstrualCycle ( Request $r ) {
        if ( Request()->header('x-glowme-key') != $_ENV['X_GLOWME_API'] ) { 
            return response()
            ->json([ 
                'error' => true, 
                'message' => "Api key error", 
                'data' => "Acceso no permitido" 
            ], 403)
            ->header("Access-Control-Allow-Origin", "*");
        } else {
            try {
                $TrackingMenstrualCycle = TrackingMenstrualCycle::select( "id", "date_at", "days" )->where("i_client", $r->id)
                ->orderBy("date_at")
                ->get();

                $inicio = 0;
                $arrayGraph = array();
                foreach ( $TrackingMenstrualCycle as $key => $item ) {
                    if ( $key == 0 ) {
                        $inicio = date("Y-m-d", strtotime($item['date_at']));
                    } else {
                        $date1 = new DateTime($inicio);
                        $date2 = new DateTime(date("Y-m-d", strtotime($item['date_at'] . " - 1 DAY")));
                        $diff = $date1->diff($date2);
                        array_push($arrayGraph, array(
                            "id" => $item['id'], 
                            "date_at" => $item['date_at'], 
                            "days" => $diff->days
                        ));
                        $inicio = date("Y-m-d", strtotime($item['date_at']));
                    }
                }

                $restResponse = 200;
                $response = array(
                    "error" => false,
                    "message" => "Consulta exitosa", 
                    "data" => $arrayGraph
                );
            } catch (QueryException $e) {
                $restResponse = 500;
                $response = array(
                    "error" => true,
                    "message" => "Error en la consulta", 
                    "data" => $e->getMessage()
                );
            }

            return response()
                ->json($response, $restResponse)
                ->header("Access-Control-Allow-Origin", "*");
        }
    }
}



