<?php

namespace App\Http\Controllers\Api\Menu;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use App\Models\SystemModules;

class DataController extends Controller {
    public function getMenu() {
        $response = array(
            "error" => false,
            "message" => "Sin error"
        );

        try {
            $sysModules = SystemModules::select(
            		"id", 
            		"name", 
            		"url", 
            		"icon", 
            		"parent", 
            		"order"
            	)
                ->orderBy("parent", "ASC")
            	->orderBy("order", "ASC")
            	->get();

            $response = array(
                "error" => true,
                "message" => "Sin error", 
                "data" => $sysModules
            );
        } catch ( QueryException $e ) {
            $response = array(
                "error" => true,
                "message" => "Error en la consulta", 
                "data" => $e->getMessage()
            );
        }

        return response()
            ->json($response, 200)
            ->header("Access-Control-Allow-Origin", "*");
    }
}
