<?php

namespace App\Http\Controllers\Api\Workouts;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Database\QueryException;
use Illuminate\Support\Facades\File;

use App\Models\WorkoutsVideos;

class WorkoutsVideoController extends Controller {
    public function getworkoutsvideo( Request $r ) {
        $response = array(
            "error" => false,
            "message" => "Sin error"
        );

        try {
            $workoutvideosvideo = WorkoutsVideos::select(
                "week", 
                "title", 
                "areas", 
                "equip", 
                "intensity", 
                "vimeo", 
                "preview", 
                "duration", 
                "videoWeb", 
                "videoMobile"
            )
            ->where("i_workout", $r->id)
            ->get();

            $response = array(
                "error" => true,
                "message" => "Sin error", 
                "data" => $workoutvideosvideo
            );
        } catch ( QueryException $e ) {
            $response = array(
                "error" => true,
                "message" => "Error en la consulta", 
                "data" => $e->getMessage()
            );
        }

        return response()
            ->json($response, 200)
            ->header("Access-Control-Allow-Origin", "*");
    }

    public function store(Request $r) {
        $response = array(
            "error" => false,
            "message" => "Sin error"
        );

        /**
        $response = array(
            "error" => false,
            "message" => "Sin error", 
            "data" => $r->post()
        );

        return response()
            ->json($response, 200)
            ->header("Access-Control-Allow-Origin", "*");
        /**/

        try {
            $data = WorkoutsVideos::where("i_workout", $r->id)->get();

            if ( count($data) == 0 ) {

                foreach ( $r->semana as $i => $week ) {
                    foreach ( $r->title[$i] as $j => $item ) {
                        $workoutvideo = new WorkoutsVideos();
                        $workoutvideo->i_workout = $r->id;
                        $workoutvideo->week = $week;
                        $workoutvideo->title = $r->title[$i][$j];
                        $workoutvideo->areas = json_encode($r->area[$i][$j]);
                        $workoutvideo->equip = json_encode($r->equip[$i][$j]);
                        //$workoutvideo->intensity = json_encode($r->intensity[$i][$j]);
                        $workoutvideo->vimeo = $r->video[$i][$j];
                        $workoutvideo->duration = $r->duration[$i][$j];
                        $workoutvideo->preview = $r->preview[$i][$j];
                        $workoutvideo->videoWeb = $r->web[$i][$j];
                        $workoutvideo->videoMobile = $r->mobile[$i][$j];
                        $workoutvideo->save();
                    }
                }

            } else {

                WorkoutsVideos::where("i_workout", $r->id)->delete();

                foreach ( $r->semana as $i => $week ) {
                    foreach ( $r->title[$i] as $j => $item ) {
                        $workoutvideo = new WorkoutsVideos();
                        $workoutvideo->i_workout = $r->id;
                        $workoutvideo->week = $week;
                        $workoutvideo->title = $r->title[$i][$j];
                        $workoutvideo->areas = json_encode($r->area[$i][$j]);
                        $workoutvideo->equip = json_encode($r->equip[$i][$j]);
                        //$workoutvideo->intensity = json_encode($r->intensity[$i][$j]);
                        $workoutvideo->vimeo = $r->video[$i][$j];
                        $workoutvideo->duration = $r->duration[$i][$j];
                        $workoutvideo->preview = $r->preview[$i][$j];
                        $workoutvideo->videoWeb = $r->web[$i][$j];
                        $workoutvideo->videoMobile = $r->mobile[$i][$j];
                        $workoutvideo->save();
                    }
                }
            }

            $response = array(
                "error" => false,
                "message" => "Sin error", 
                "data" => []
            );
        } catch ( QueryException $e ) {
            $response = array(
                "error" => true,
                "message" => "Error en la consulta", 
                "data" => $e->getMessage()
            );
        }
        

        return response()
            ->json($response, 200)
            ->header("Access-Control-Allow-Origin", "*");
    }
}