<?php

use Illuminate\Support\Facades\Route;

use App\Http\Controllers\stripe\StripeController;
use App\Http\Controllers\paypal\PaypalController;
use App\Models\PlanSemanalControl;

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [StripeController::class, "index"]);
Route::post('/create', [StripeController::class, "create"]);
Route::post('/create-customer', [StripeController::class, "createCustomer"]);
Route::post('/get-customer', [StripeController::class, "getCustomer"]);
Route::post('/update-customer', [StripeController::class, "updateCustomer"]);
Route::post('/customer-subscribe', [StripeController::class, "customerSubscribe"]);

Route::post('/paypal-intent', [StripeController::class, "paypalIntent"]);

Route::post('/create-products', [StripeController::class, "createProducto"]);
Route::post('/create-price', [StripeController::class, "createPrice"]);

Route::get('/paypal', [PaypalController::class, "index"]);
Route::get('/paypal-create', [PaypalController::class, "create"]);


/* Webhooks */
Route::post('/stripe-webhook', [StripeController::class, "stripeWebhook"]);
Route::post('/paypal-webhook', [PaypalController::class, "paypalWebhook"]);


Route::get("/test", function() {
    $cliente = 202;
    $posicion = 1;
    $PlanSemanalControl = PlanSemanalControl::select("json")->where("i_client", $cliente)->orderBy("id", "DESC")->first()->toArray();
    $toArray = json_decode($PlanSemanalControl['json'], true); 
    $salida = array(); 
    foreach ( $toArray[$posicion]['dias'] as $item ) {
        array_push ( $salida,  array( $item['dia'], substr($item['fecha'], 0, -5), $item['comidas']['alimento1']['nombre'], $item['comidas']['alimento2']['nombre'], $item['comidas']['alimento3']['nombre'], $item['comidas']['alimento4']['nombre'], $item['comidas']['alimento5']['nombre'] ) );
    }
    $pdf = PDF::loadView('menu.print', compact('salida'));
    //return $pdf->download('menu.pdf');
    $pdf->save( $_SERVER['DOCUMENT_ROOT'] . '/pdf/menu/menu_'.$cliente.'.pdf');
    return view("menu.print", compact('salida'));
});

Route::get( "test-mail", function() {
    $mail = new PHPMailer(true);
    $mail->Host = "smtp.gmail.com";
    $mail->Port       = 587;
    $mail->SMTPSecure = '';
    $mail->SMTPAuth   = true;
    $mail->IsHTML(true);
    $mail->CharSet = 'UTF-8';

    $mail->Username = "hola@glowmeapp.com";
    $mail->Password = "ckqbyhujrpdesrrk";
    $mail->SetFrom('hola@glowmeapp.com', 'Hola GlowMe');
    $mail->addReplyTo('hola@glowmeapp.com', 'Hola GlowMe');

    $mail->Subject = "áéíóúñ";
    $mail->Body = "áéíóúñ";
    $mail->AddAddress('mauricio.salinas@metodika.mx', 'Leads');

    $mail->Send();
});

Route::get('/clear-cache', function() {
    $exitCode = Artisan::call('config:clear');
    $exitCode = Artisan::call('config:cache');
    $exitCode = Artisan::call('route:clear');
    $exitCode = Artisan::call('route:cache');
    $exitCode = Artisan::call('view:clear');
    $exitCode = Artisan::call('view:cache');
    $exitCode = Artisan::call('cache:clear');
    $exitCode = Artisan::call('optimize:clear');
    return 'DONE'; //Return anything
});